from os.path import join
import sys
import os
import random
import time
try:
    import configparser
except ImportError:
    # Python 2.x fallback
    import ConfigParser as configparser

# this import trigger a connection to Hecuba database
# from hecuba import StorageObj

# COMPSs/PyCOMPSs imports
from pycompss.api.task import task
from pycompss.api.binary import binary
from pycompss.api.constraint import constraint
from pycompss.api.mpi import mpi
from pycompss.api.api import compss_wait_on
from pycompss.api.api import compss_barrier
from pycompss.api.api import TaskGroup
from pycompss.api.api import compss_barrier_group
from pycompss.api.parameter import *
from pycompss.api.on_failure import on_failure

# project imports
from esm_ensemble_init import *
#from hecuba.esm_dynamic_analysis_results import *

# things we need:
# 1 - every 30 seconds, check the state of state of the members and determine which members to prune
# 2 - every n time steps,  perform the analysis of the model data

def get_members_state(exp_id):
   # todo add connection to Hecuba
   print("######################## checking member state for experiment" + exp_id + "#########################")
   exp_member_status = esm_dynamic_analysis_results("Keyspace.Table")
   return exp_member_status


def esm_dynamic_analysis(exp_id):
    print("######################## performing dynamic analysys for experiment" + exp_id + "#########################")

@on_failure(management='IGNORE', returns=0)
@task( returns=int, exp_id={Type:IN}, log_pruning={Type: FILE_OUT, StdIOStream: STDOUT})
def esm_pruning(exp_id, log_pruning):
   # 1 - connect to hecuba and obtain values
   #t = threading.Timer(10.0, esm_pruning, [exp_id, log_pruning])
   #t.start()
   try:
     print("################################################### lauching pruning " + str(time.time()) + "###################################################")
     get_members_state(exp_id)
     return 0
   except:
     print("ERRROR !!!!!!!!!!! An exception occurred")


# for testing purposes
if __name__ == "__main__":
   print("Running Dynamic analysis Agent" )
   # first parameter: number of ensemble members
   # exp_id = str(sys.argv[0])
   # config = configparser.ConfigParser()
   # config.read(os.path.join(os.path.dirname(__file__), 'config', 'esm_ensemble.conf'))
   # top_working_dir = config['common']['top_working_dir']
   # exp_flag =  top_working_dir + "/" + exp_id + ".finished"
   exp_id = str(sys.argv[0])
   exp_settings = compss_wait_on(esm_ensemble_init(exp_id, False))
   top_working_dir = exp_settings['common']['top_working_dir']
   exp_flag = top_working_dir + "/" + exp_id + ".finished"

   i = 0
   while (i < 10) :
      log_file =  exp_id + "_pruning_log.out"
      if not os.path.exists(exp_flag):
        compss_wait_on(esm_pruning(exp_id, log_file ))
        time.sleep(5)
      else:
        file = open(log_file, "w")
        file.write("Shutting down Pruning analysis agent")
        file.close()
        break

